/*------------------------------------------------------------------------------
 bin/djv_view/window_factory.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include "app.h"
#include "window.h"

namespace djv_view {
namespace window {

Factory::~Factory()
{
  DJV_DBG_OBJ("window::Factory::~Factory");
  
  for (uint i = 0; i < _list.size(); ++i)
    _list[i]->del();
}

Widget * Factory::add(const Widget * copy)
{
  DJV_DBG_OBJ("window::Factory::add");
  DJV_DBG_PRN("copy = " << int(copy));
  
  Widget * window = new Widget(copy);
  _list += window;
  return window;
}

void Factory::del(Widget * in)
{
  DJV_DBG_OBJ("window::Factory::del");
  DJV_DBG_PRN("in = " << int(in));
  
  in->del();
  
  _list.erase(std::find(_list.begin(), _list.end(), in));  

  // Exit application if no windows are left.
  
  if (! _list.size()) app()->exit();
}

const List<Widget *> Factory::list() const { return _list; }

}
}

