/*------------------------------------------------------------------------------
 include/djv_type/type.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_TYPE_H
#define DJV_TYPE_H

#include <stddef.h>
//#if ! defined(WIN32)
#include <inttypes.h>
//#endif
#include <float.h>
#include <memory>
//#include <string>
#if defined(WIN32)
#define WIN32_LEAN_AND_MEAN
#if ! defined(NOMINMAX)
#define NOMINMAX
#endif
#include <windows.h>
#endif

//------------------------------------------------------------------------------
// Types

typedef unsigned int uint;

#if defined(WIN32)

/*typedef INT8 int8_t;
typedef INT16 int16_t;
typedef INT32 int32_t;
typedef INT64 int64_t;

typedef UINT8 uint8_t;
typedef UINT16 uint16_t;
typedef UINT32 uint32_t;
typedef UINT64 uint64_t;*/

typedef int uid_t;
typedef int gid_t;

#endif

//------------------------------------------------------------------------------
// Declarations

namespace djv_base {

namespace list {
template<typename T>
class List;
}
namespace str {
class Str;
}
namespace error {
class Error;
}

using list::List;
using str::Str;
using error::Error;

}

#endif

