/*------------------------------------------------------------------------------
 include/djv_image/gl_.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

namespace djv_image {
namespace gl {

inline void box(const Box2i & in)
{
  glVertex2i(in.x, in.y);
  glVertex2i(in.x, in.y + in.h);
  glVertex2i(in.x + in.w, in.y + in.h);
  glVertex2i(in.x + in.w, in.y);
}

inline void box(const Box2f & in)
{
  glVertex2d(in.x, in.y);
  glVertex2d(in.x, in.y + in.h);
  glVertex2d(in.x + in.w, in.y + in.h);
  glVertex2d(in.x + in.w, in.y);
}

inline void box(const Box2i & in, const Vec2f uv [4])
{
  glTexCoord2d(uv[0].x, uv[0].y);
  glVertex2i(in.x, in.y);
  glTexCoord2d(uv[1].x, uv[1].y);
  glVertex2i(in.x, in.y + in.h);
  glTexCoord2d(uv[2].x, uv[2].y);
  glVertex2i(in.x + in.w, in.y + in.h);
  glTexCoord2d(uv[3].x, uv[3].y);
  glVertex2i(in.x + in.w, in.y);
}

inline void box(const Box2f & in, const Vec2f uv [4])
{
  glTexCoord2d(uv[0].x, uv[0].y);
  glVertex2d(in.x, in.y);
  glTexCoord2d(uv[1].x, uv[1].y);
  glVertex2d(in.x, in.y + in.h);
  glTexCoord2d(uv[2].x, uv[2].y);
  glVertex2d(in.x + in.w, in.y + in.h);
  glTexCoord2d(uv[3].x, uv[3].y);
  glVertex2d(in.x + in.w, in.y);
}

}
}

