/*------------------------------------------------------------------------------
 include/djv_ui/prefs.h
 
 Preferences
 -----------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_PREFS_H
#define DJV_UI_PREFS_H

#include <djv_image/time.h>
#include <djv_ui/base.h>

class Fl_Preferences;

namespace djv_ui {
namespace prefs {

//------------------------------------------------------------------------------
// Preferences

class Prefs
{
public:

  Prefs(const Str & name);
  Prefs(const Prefs &, const Str & group);
  Prefs(Prefs *, const Str & group);
  ~Prefs();

  // Value.
  
  void set(const Str &, const Str &);
  void del(const Str &);
  void del_group(const Str &);
  bool get(const Str &, Str *) const;
  List<Str> list() const;
  List<Str> group() const;

private:

  std::auto_ptr<Fl_Preferences> _prefs;
};

//------------------------------------------------------------------------------
// Conversion

template<typename T>
inline void set(Prefs *, const Str &, const T &);
template<typename T>
inline bool get(Prefs *, const Str &, T *);

//------------------------------------------------------------------------------
// Global

Prefs * prefs();
Prefs * prefs_global();

}
}

#include <djv_ui/prefs_.h>

#endif

