/*------------------------------------------------------------------------------
 lib/djv_base/error.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_base/error.h>
#include <djv_base/str.h>

namespace djv_base {
namespace error {

Error::Error()
{}

Error::Error(const Str & in) :
  _str(in)
{}

Error::Error(const Str & prefix, const Str & in) :
  _str(prefix + " " + in)
{}

const Str & Error::str() const { return _str; }
  
Error::operator Str () const { return _str; }

Str format(const Error & in)
{
  return str::Format(error_format).arg(in.str());
}

void print(const Error & in)
{
  ::printf("%s\n", format(in).c_str());
}

const Str
  error_format = "[ERROR] %%";

}
}
