/*------------------------------------------------------------------------------
 lib/djv_image/gl_offscreen.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG

#include "gl_offscreen.h"

namespace djv_image {
namespace gl_offscreen {

_Offscreen::~_Offscreen()
{}

_Pbuffer_Factory::~_Pbuffer_Factory()
{}

Buffer::~Buffer()
{}

Global::Global() throw (Error) :
  _buffer(PBUFFER)
{
  DJV_DBG_OBJ("Global::Global");
  DJV_DBG_PRN("buffer = " << _buffer);
  
  if (gl::FIXED == gl::global()->pipeline()) _buffer = PBUFFER;
  else if (GLEW_EXT_framebuffer_object) _buffer = FBO;
  
  _global = std::auto_ptr<_Global>(new _Global);
}

Global::~Global()
{
  DJV_DBG_OBJ("Global::~Global");
}

void Global::buffer(BUFFER in)
{
  _buffer = in;
}

BUFFER Global::buffer() const { return _buffer; }

Buffer * Global::buffer_create() const
{
  DJV_DBG_OBJ("Global::buffer_create");
  
  const BUFFER buffer = this->buffer();
  DJV_DBG_PRN("buffer = " << buffer);
  
  switch (buffer)
  {
    case PBUFFER: return new _Pbuffer(_global->pbuffer());
    case FBO: return new _Fbo(_global->fbo());
  }
  return 0;
}

}
}
