/*------------------------------------------------------------------------------
 lib/djv_image/glx_offscreen.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#if ! defined(WIN32) && ! defined(DJV_MACOSX)

//#define DJV_DBG

#include "glx_offscreen.h"

namespace djv_image {
namespace gl_offscreen {

Global::_Global::_Global() throw (Error)
{
  DJV_DBG_OBJ("Global::_Global::_Global");
  
  _pbuffer = std::auto_ptr<_Pbuffer_Factory>(new _Glx_Pbuffer_Factory);
  _pbuffer->init();

  _fbo = std::auto_ptr<_Fbo_Factory>(new _Fbo_Factory);
  _fbo->init();
}

Global::_Global::~_Global()
{
  DJV_DBG_OBJ("Global::_Global::~_Global");
}

}
}

#endif
