/*------------------------------------------------------------------------------
 lib/djv_image/pixel_etc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_image/pixel.h>

namespace djv_image {
namespace pixel {

DJV_STR_OPERATOR_SET(FORMAT, label_format())
DJV_STR_OPERATOR_GET(FORMAT, label_format())
DJV_STR_OPERATOR_SET(TYPE, label_type())
DJV_STR_OPERATOR_GET(TYPE, label_type())
DJV_STR_OPERATOR_SET(PIXEL, label_pixel())
DJV_STR_OPERATOR_GET(PIXEL, label_pixel())

const List<Str> & label_format()
{
  static const List<Str> data = List<Str>() <<
    "L" <<
    "LA" <<
    "RGB" <<
    "RGBA";
  return data;
}

const List<Str> & label_type()
{
  static const List<Str> data = List<Str>() <<
    "U8" <<
    "U10" <<
    "U16" <<
    "F16" <<
    "F32";
  return data;
}

const List<Str> & label_pixel()
{
  static const List<Str> data = List<Str>() <<
    "L U8" <<
    "L U16" <<
    "L F16" <<
    "L F32" <<
    "LA U8" <<
    "LA U16" <<
    "LA F16" <<
    "LA F32" <<
    "RGB U8" <<
    "RGB U10" <<
    "RGB U16" <<
    "RGB F16" <<
    "RGB F32" <<
    "RGBA U8" <<
    "RGBA U16" <<
    "RGBA F16" <<
    "RGBA F32";
  return data;
}

Dbg & operator << (Dbg & dbg, FORMAT in) { return dbg << str::label(in); }
Dbg & operator << (Dbg & dbg, TYPE in) { return dbg << str::label(in); }
Dbg & operator << (Dbg & dbg, PIXEL in) { return dbg << str::label(in); }

}
}
