/*------------------------------------------------------------------------------
 lib/djv_image/wgl.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef _DJV_IMAGE_WGL_H
#define _DJV_IMAGE_WGL_H

#include <djv_image/gl.h>

namespace djv_image {
namespace gl {

//------------------------------------------------------------------------------
// WGL

class _Wgl_Device : public Device
{
public:

  _Wgl_Device();
  ~_Wgl_Device();

  void init() throw (Error);

  HDC device() const { return _device; }
  
private:

  HWND _id;
  HDC _device;
  HGLRC _context;
};

//------------------------------------------------------------------------------
// Labels

static const Str
  error_glew = "GLEW",
  error_glew_init = "Initialize: %%",
  error_wgl = "WGL",
  error_wgl_context_create = "Context Create: %%",
  error_wgl_context_bind = "Context Bind: %%",
  error_wgl_pixel_choose = "Pixel Choose: %%",
  error_win32 = "Win32",
  error_win32_module = "GetModuleHandle: %%",
  error_win32_register = "RegisterClass: %%",
  error_win32_window = "CreateWindow: %%",
  error_win32_device = "GetDC: %%",
  error_win32_pixel_choose = "ChoosePixelFormat: %%",
  error_win32_pixel_set = "SetPixelFormat: %%";

}
}

#endif
