/*------------------------------------------------------------------------------
 lib/djv_ui/image_io.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/image_io.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/tab.h>

namespace djv_ui {
namespace image_io {

Prefs_Load::Prefs_Load() :
  sig(this)
{
  // Widgets.
  
  tab::Widget * tab_widget = new tab::Widget;
  
  const List<djv_image::io::Load *> & load_list =
    djv_image::io::global()->load()->list();
  for (uint i = 0; i < load_list.size(); ++i)
  {
    Load * widget = global()->load()->get(load_list[i]);
    if (! widget) continue;
    widget->set(load_list[i]);
    widget->sig.set(this, widget_callback);
    tab_widget->tab_add(load_list[i]->name(), widget);
  }
  
  // Layout.
  
  Layout_V * layout = new Layout_V(this);
  layout->margin(0);
  layout->add(tab_widget);
}

void Prefs_Load::widget_callback(djv_image::io::Plugin * in)
{
  DJV_DBG_OBJ("Prefs_Load::widget_callback");
  DJV_DBG_PRN("in = " << in->name());
  
  sig.emit(in);
  global()->sig.emit(in);
}

Prefs_Save::Prefs_Save() :
  sig(this)
{
  // Widgets.
  
  tab::Widget * tab_widget = new tab::Widget;

  const List<djv_image::io::Save *> & save_list =
    djv_image::io::global()->save()->list();
  for (uint i = 0; i < save_list.size(); ++i)
  {
    Save * widget = global()->save()->get(save_list[i]);
    if (! widget) continue;
    widget->set(save_list[i]);
    widget->sig.set(this, widget_callback);
    tab_widget->tab_add(save_list[i]->name(), widget);
  }
  
  // Layout.
  
  Layout_V * layout = new Layout_V(this);
  layout->margin(0);
  layout->add(tab_widget);
}

void Prefs_Save::widget_callback(djv_image::io::Plugin * in)
{
  DJV_DBG_OBJ("Prefs_Save::widget_callback");
  DJV_DBG_PRN("in = " << in->name());
  
  sig.emit(in);
  global()->sig.emit(in);
}

}
}
