/*------------------------------------------------------------------------------
 lib/djv_ui/layout_item.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_ui/layout.h>

namespace djv_ui {
namespace layout {

Item::Item(ITEM item) :
  _item(item),
  _parent(0)
{
  _size[0] = _size[1] = STRETCH;
  _align[0] = _align[1] = CENTER;
}

Item::~Item()
{}

void Item::dirty()
{}

void Item::update()
{
  if (_parent) _parent->update();
}

void Item::geom(const Box2i & in)
{
  _geom = in;
}

void Item::size_hint(const Vec2i & in)
{
  _size_hint = in;
}

void Item::size(SIZE h, SIZE v)
{
  _size[0] = h;
  _size[1] = v;
}

void Item::align(ALIGN h, ALIGN v)
{
  _align[0] = h;
  _align[1] = v;
}

void Item::group(const List<Item *> & in)
{
  _group = in;
}

void Item::parent(Item * in)
{
  _parent = in;
}

}
}
