/*------------------------------------------------------------------------------
 plugin/djv_jpeg/base.h

 Image I/O - JPEG
 ----------------
 
 Joint Photographic Experts Group image file format.

 Requires:
 
 * libjpeg - http://www.ijg.org
 
 Support:
 
 * Image data: L, RGB, 8-bit.
 * File compression.

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_JPEG_BASE_H
#define DJV_JPEG_BASE_H

#include <djv_image/base.h>
#include <stdio.h>
namespace libjpeg { // XXX WIN32 conflicts?
extern "C" {
#include <jpeglib.h>
}
}
#include <setjmp.h>

namespace djv_jpeg {
using namespace djv_base;
using namespace djv_image;

//------------------------------------------------------------------------------
// Information

static const Str name = "JPEG";

static const List<Str> extension_list = List<Str>() <<
  ".jpeg" <<
  ".jpg" <<
  ".jfif";

//------------------------------------------------------------------------------
// Errors

struct Jpeg_Error
{
  struct libjpeg::jpeg_error_mgr pub;
  char msg [JMSG_LENGTH_MAX];
  jmp_buf jump;
};

extern "C" {

void djv_jpeg_error(libjpeg::j_common_ptr);
void djv_jpeg_warn(libjpeg::j_common_ptr, int);

}

}

#endif

