//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/button.h>
#include <djv_ui/window.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, callback, bool) { print("button"); }
  DJV_CALLBACK(App, callback2, bool) { print("button 2"); }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("button", argc, argv),
  _window(0)
{
  using namespace djv_ui;
  
  DJV_DBG_OBJ("App::App");

  valid(true);
  
  button::Push * widget = new button::Push("Button");
  button::Push * widget2 = new button::Push("Button 2");
  _window = new window::Widget(name());

  Layout_V * layout = new Layout_V(_window);
  layout->add(widget);
  layout->add(widget2);
  
  _window->size(_window->size_hint());

  DJV_DBG_PRN("widget = " << widget->size_hint());
  DJV_DBG_PRN("widget2 = " << widget2->size_hint());
  DJV_DBG_PRN("window = " << _window->size_hint());
  
  _window->show();

  widget->sig.set(this, callback);
  widget2->sig.set(this, callback2);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

