#!/bin/csh

# XXX Binaries contain full path to libs.
set build_dir = /Users/darby/build/djv

set lib = `ls -1 *.dylib`
set plugin = `ls -1 *.so`
set bin = (djv_ls djv_info djv_convert test_audio test_glsl) 

foreach i ($lib)

  echo $i

  echo "  Update library ID."
  set cmd = "install_name_tool -id @executable_path/$i $i"
  $cmd

  echo "  Update library paths."
  foreach j ($lib)
    set cmd = "install_name_tool -change $build_dir/$i @executable_path/$i $j"
    $cmd
  end

  echo "  Update plugin paths."
  foreach j ($plugin)
    set cmd = "install_name_tool -change $build_dir/$i @executable_path/$i $j"
    $cmd
  end

  echo "  Update binary path."
  foreach j ($bin)
    set cmd = "install_name_tool -change $build_dir/$i @executable_path/$i $j"
    $cmd
  end

  echo ""
end

